<?php


	
	// load core files
	include("../../config.php");
	include($baseURL."css/design.php");
	include($baseURL."header.php");
	
	// check if settings already exists and if so, load it, otherwise set parameters to default values
	if(file_exists("settings.php")){
		include("settings.php");
	}
	
	
?>
<!DOCTYPE html>
<html>
	<head>
		<title><?php echo $pageName?></title>
		<?php metaHeader()?>
		<style>
			
		</style>
	</head>
	<body>
		<div id="main_top">
			<?php bodyHeader()?>
			<?php include($baseURL."menu.php");?>
		</div>
		<div id="main" style="text-align:justify">
		<h1>MeteoTemplate Plugin : TRIGGERS</h1>
<a href="#overview">1-Overview</a><br/>
<a href="#installation">2-Installation</a><br/>
<a href="#cron">3-Setup a Cron job</a><br/>
<a href="#configuration">4-Configuration</a><br/>
<a name="overview"></a><h2>1 - Overview</h2>
The Triggers plugin allows a Meteotemplate site administrator to create a serie of conditions based on variables from the site.<BR/> 
These conditions will be evaluated at regular interval and their status (True or Fase) will be store for later use by other Plugins (like the Notifications section of the App plugin) <BR/>
<img src="https://www.elspinars.es/imgs/tutos/triggers-02.JPG" /><BR/>
<a name="installation"></a><h2>2 - Installation</h2>
The triggers plugins is installed as any other Meteotemplate plugin: <BR/>
<ul><li>Download the plugin from <a href="https://www.elspinars.es/dev/triggers.zip">https://www.elspinars.es/dev/triggers.zip</a></li>
<li>Unzip the plugin in the plugins folder of your meteo template site</li></ul>
<img src="https://www.elspinars.es/imgs/tutos/triggers-01.JPG" /><BR/>
<a name="cron"></a><h2>3 - Setup a Cron job</h2>
The page updateTriggers.php must be called at regular interval.<br/>
For this, we will use a cron job. You can use the cron functionnality of your site (if it has it) or use an external tool.
The example below is taken from <a href="https://cron-job.org">cron-job.org</a>, the exernal tool I uses for scheduling tasks related to MeteoTemplate
<img src="https://www.elspinars.es/imgs/tutos/triggers-03.JPG" /><BR/>
The url pointing to the page should include your update password : https://www.mymeteotemplatepage.com/template/plugins/triggers/updateTriggers.php?password=YourPassword
<a name="configuration"></a>4<h2> - Configuration</h2>
<ul>
<li>Go to the "Configure Plugins" section of your Meteotemplate administration panel<br/>
<img src="https://www.elspinars.es/imgs/tutos/triggers-04.JPG" />
</li>
<li>Click on the "Edit Settings" link on the right of the triggers row<br/>
<img src="https://www.elspinars.es/imgs/tutos/triggers-05.JPG" />
</li>
<li>The first part of the setup page displays a list of variables available to be used in the Triggers. <br/>
<img src="https://www.elspinars.es/imgs/tutos/triggers-06.JPG" /><BR/>
This list will be extended over time to add the datapoint you need or depending on the blocks or plugin you may have installed.<br/>
For now, it only displays the content of the meteotemplateLive.txt  (and the duration of your configured routes if you have installed the <a href="https://www.elspinars.es/dev/trafficAlert.zip">TrafficAlert</a> block)<br/>
As an example, you can use %%T for the current temperature or %%H for the current humidity, etc. 
</li>
<li>Click on the "Add a Trigger" button. A new trigger will be added to the list : <br/>
<img src="https://www.elspinars.es/imgs/tutos/triggers-07.JPG" /><BR/>
<ul>
<li><b>Id</b> : Enter a unique identifier. (eg TempHigh)</li>
<li><b>Display name</b> : Enter a meaningful name that will be displayed in other plugins (eg High Temperature)</li>
<li><b>Enabled/Disable</b> : if disable, the trigger will not be processed by the cron job (and the panel where you enter the condition will be hidden)</li>
<li><b>Delete</b> : will delete the trigger. Note that you can only delete the last trigger. ( So if you need to delete the first one, you have to delete them all. Better to just disable it in this case)  
<li><b>Description</b> : Enter short description that explains the condition (eg Temperature is higher than 30 degrees)</li>
<li><b>Condition</b> : Enter a condition that will return true or false. Use the PHP syntaxis (&amp;&amp; for and operator, || for or operator, == for =, &gt;, &lt;, etc)<br/>
You can use any variable displayed in the first section of the page to build your condition (remember to put "%%" before the variable, like %%W for wind).<br/> 
You can keep it simple (like %%T&gt;30 ) or make it more complex (like ((%%T&gt;30) && (%%T&lt;35)) && ((%%RR&gt;10) || (%%R&gt;30)). Your call. <br/>
When you are satisfied with your condition, you can test it by Clicking on the "Test Condition" button. The result on the right will then display True or False.</li>
</ul>
<li> <b>Click on Save</b></li>
</li>
		</div>
		<?php include($baseURL."footer.php");?>
	</body>
</html>