<?php

	############################################################################
	# 	
	#	Meteotemplate
	# 	http://www.meteotemplate.com
	# 	Free website template for weather enthusiasts
	# 	Author: Jachym
	#           Brno, Czech Republic
	# 	First release: 2015
	#
	############################################################################
	#
	#	API Viewer
	#
	############################################################################
	#	Version and change log
	#
	# 	v1.0 - Jun 1, 2017
	# 		- initial release
	#
	############################################################################
	
	
	include("../../config.php");
	include($baseURL."css/design.php");
	include($baseURL."header.php");

	if(!file_exists("settings.php")){
		echo "Missing settings file, create one using the plugin setup.";
		die();
	}
	else{
		include("settings.php");
	}
	
?>
<!DOCTYPE html>
<html>
	<head>
		<title>API <?php echo lang('viewer','c')?></title>
		<?php metaHeader()?>
		<style>
		</style>
	</head>
	<body>
		<div id="main_top">
			<?php bodyHeader()?>
			<?php include($baseURL."menu.php");?>
		</div>
		<div id="main" style="text-align:center">
			<h1>API <?php echo lang('viewer','c')?></h1>
			<!--<h2>Please note: this is a demo, I don't have most of these sensors so it uses dummy data. For you it will show all the parameters that the script finds in the API file generated from the input of your software or whichever update type you use.</h2>-->
			<div style="width:98%;margin:0 auto" id="viewerDiv">
				
			</div>
			<br><br>
		</div>
		<script>
			$.fn.animateHighlight = function(highlightColor, duration) {
				var highlightBg = highlightColor || "#fff";
				var animateMs = duration || 1500;
				var originalBg = this.css("color");
				if (notLocked) {
					notLocked = false;
					this.stop().css("color", highlightBg)
						.animate({color: originalBg}, animateMs);
					setTimeout( function() { notLocked = true; }, animateMs);
				}
			};	
			apiViewerUpdate();
			setInterval(function(){ apiViewerUpdate(); }, (<?php echo $updateIntervalAPI?>*1000));
			function apiViewerUpdate(){
				rand = Math.round(Math.random()*1000000);
				$("#viewerDiv").load("updateViewer.php?"+rand);
				$("#apiTime").animateHighlight("#<?php echo $color_schemes[$design2]['400']?>", 10000);
			}
			var notLocked = true;							
		</script>
		<?php include($baseURL."footer.php");?>
	</body>
</html>