<?php

	// check acces authorization
	session_start();
	if($_SESSION['user']!="admin"){
		echo "Unauthorized access.";
		die();
	}
	
	// load core files
	include("../../config.php");
	include($baseURL."css/design.php");
	include($baseURL."header.php");
	
	// check if settings already exists and if so, load it, otherwise set parameters to default values
	/*if(file_exists("settings.php")){
		include("settings.php");
	}*/
	
	if(file_exists("settings.txt")){
		$variables = json_decode(file_get_contents("settings.txt"),true);
	}
	
	include("variables.php");
	
	
?>
<!DOCTYPE html>
<html>
	<head>
		<title><?php echo $pageName?></title>
		<?php metaHeader()?>
		<style>
			.icon{
				font-size:3.0em;
			}
			.iconDiv{
				display: inline-block;
				padding: 10px;
				margin: 0 auto;
				text-align: center;
				width: 150px;
			}
	
		</style>
	</head>
	<body>
	<script>	
	function loadTriggers(){
	<?php	
	
	for ($i = 1; $i <= $variables["numTriggers"]; $i++) {
		echo 'addTrigger();'.PHP_EOL;
	}
	foreach($variables as $key=>$value){
		${$key} = $value;
		echo '$(\'#';
		echo $key;
		echo '\').val(\'';
		echo $value;
		echo '\');'.PHP_EOL;		
	}	
	?>
	}
	
	var triggerNum=0;
	function deleteTrigger(myTriggerNum){
		if (confirm('Are you sure you want to delete Trigger #'+myTriggerNum+' - '+$('#triggerId'+myTriggerNum).val()+'/'+$('#triggerName'+myTriggerNum).val())) {
			$('#trigger'+myTriggerNum).remove();
			triggerNum--;
			$('#numTriggers').val(myTriggerNum);
			if(triggerNum>0){
				$('#deleteTrigger'+triggerNum).show();
			}
		}
	}
	
	function testTrigger(myTriggerNum) {
		cond = $('#triggerCondition'+myTriggerNum).val();
		console.log("Initial condition = "+cond);
		url = 'eval.php?condition='+encodeURIComponent(cond);
		url+='&password=<?php echo $updatePassword?>';
		console.log('URL = '+url);
		$('#triggerResult'+myTriggerNum).load(url, function() {	
		console.log("condition result loaded");
		});
	}
	function addTrigger(){
		triggerNum++;
		var triggerString = '<div style="border-bottom: 1px solid white;" id="trigger'+triggerNum+'">';
		triggerString+='<h3>Trigger #'+triggerNum+'</h3> Id (must be unique) : <input id="triggerId'+triggerNum+'" name="triggerId'+triggerNum+'" class="button2"  value="triggerId'+triggerNum+'"/>  ';
		triggerString+='  Display Name : <input id="triggerName'+triggerNum+'" name="triggerName'+triggerNum+'" class="button2"  value="triggerName'+triggerNum+'"/>  ';
		triggerString+='<select id="triggerActive'+triggerNum+'" name="triggerActive'+triggerNum+'" onChange="$(\'#triggerPanel'+triggerNum+'\').toggle();" class="button2">';
		triggerString+='<option value="true" selected>Enabled</option>';
		triggerString+='<option value="false">Disable</option>';
		triggerString+='</select>';
		triggerString+='    <span id="deleteTrigger'+triggerNum+'" class="button2 fa fa-trash" onClick="deleteTrigger('+triggerNum+');"> Delete   </span><br/><br/>';
		triggerString+='<div id="triggerPanel'+triggerNum+'">';
		triggerString+='<table><tr>';
		triggerString+='<td style="text-align:left;"><h4>Description : </h4></td><td  style="text-align:left;" colspan="2"><input id="triggerDescription'+triggerNum+'" size="50" name="triggerDescription'+triggerNum+'" class="button2"  value="triggerDescription'+triggerNum+'"/></td>  ';
		triggerString+='</tr><tr>';
		triggerString+='<td style="text-align:left;"><h4>Condition : </h4></td>';
		triggerString+='<td  style="text-align:left;"><textarea id="triggerCondition'+triggerNum+'" name="triggerCondition'+triggerNum+'" cols="40" rows="5" class="button2">(%%T>30) && (%%H>60)</textarea></td>';
		triggerString+='<td  style="text-align:left;"><span id="testTrigger'+triggerNum+'" class="button2 fa fa-refresh" onClick="testTrigger('+triggerNum+');"> Test Condition  </span>  ';
		triggerString+=' Result : <span id="triggerResult'+triggerNum+'">Click on Test Condition button to refresh result</span></td>';
	//	triggerString+='</tr><tr><td  style="text-align:left;">Min update interval (s): </td><td colspan="2"  style="text-align:left;"><input id="triggerMinUpdate'+triggerNum+'" name="triggerMinUpdate'+triggerNum+'" class="button2"  value="60"></td></tr></table>';
		triggerString+='</tr></table>';
		triggerString+='</div>'; //end of trigger panel
		triggerString+='</div>';
		
		if(triggerNum>1){
				$('#deleteTrigger'+(triggerNum-1)).hide();
			}
		$('#triggersPanel').append(triggerString); 
		$('#numTriggers').val(triggerNum);
	}	
	</script>
		<div id="main_top">
			<?php bodyHeader()?>
			<?php include($baseURL."menu.php");?>
		</div>
		<div id="main" style="text-align:justify">
			<h1>Triggers - Setup</h1>
			<table><tr><td style="text-align:left">
			This plugin allows you to define different triggers that will activate depending on the value of one or a combination of variables. <br>
			Don't forget to setup a cron job that will call the updaterTriggers.php page (like https://www.mymeteotemplatesite.com/plugins/triggers/updateTriggers.php?password=XXXXX) <br>
			Cron job should be executed at reasonnable interval (I have mine every 10 min)<br>
			Note that you can use the variables in the notifications message in the App Plugin. 
			</td><td><div class="iconDiv"><a href="help.php" target="_new"><i class="icon fa fa-question-circle"></i></a></div></td></tr></table>
			<?php 
			$totalVariables = count($data);
			
			$tableVariables = '';
			$currentValue=0;
			$currentTables=0;
			$maxLines = floor($totalVariables/5);
			echo '<!-- max lines = '.$maxLines.'-->'.PHP_EOL;
			foreach($data as $key => $val){ 
					$currentValue=$currentValue+1;
					if ($currentValue==1) {
						$tableVariables =  $tableVariables.'<td style="vertical-align: top;"><table border="1" style="width:100%"><tr><td><b>Variable</b></td><td><b>Value</b></td></tr>';
					}						
						$tableVariables = $tableVariables.'<tr><td>%%'.$key . '</td><td>' . $val.'</td></tr>';
					if ($currentValue==$maxLines) {
						$tableVariables = $tableVariables. '</table></td>';
						$currentValue=0;
						$currentTables=$currentTables+1;
					}						
			}
			
			if ($currentValue!=0) {
				for ($i = $currentValue; $i <= $maxLines; $i++) {
					//$tableVariables = $tableVariables.'<tr><td></td><td></td></tr>';
				}
				$tableVariables = $tableVariables. '</table></td>';
				$currentTables=$currentTables+1;
			}
			$tableVariables = '<table style="width:98%"><tr><td colspan="'.$currentTables.'">Variables available</td></tr><tr>'.$tableVariables.'</tr></table>';
			echo $tableVariables;
	?>
			<br>
			<form method="POST" action="saveSettings.php" target="_blank">
				<br><br>
					<div style="width:100%;margin:0 auto;text-align:left"><span class="button2" onclick="addTrigger();">&nbsp;&nbsp;&nbsp;&nbsp;Add a Trigger&nbsp;&nbsp;&nbsp;&nbsp;</span>&nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" value="Save" class="button2"></div>
					<input type="hidden" id="numTriggers" name="numTriggers" value="0"/>
					<br/>
					<div id="triggersPanel">
					</div>
					<div style="width:50%;text-align:center;margin:0 auto">
						<span class="button2" onclick="addTrigger();">&nbsp;&nbsp;&nbsp;&nbsp;Add a Trigger&nbsp;&nbsp;&nbsp;&nbsp;</span>&nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" value="Save" class="button2">
					</div>
					<br><br>
				<div style="width:50%;text-align:center;margin:0 auto">
					<input type="submit" value="Save" class="button2">
				</div>
			</form>
		</div>
		<?php include($baseURL."footer.php");?>
			<script>
		$(document).ready(function() {
		  <?php if($numTriggers>0) {?>          
			loadTriggers();		 
		  <?php } ?>
      })
		</script>
	</body>
</html>